Index: protocols/yahoo/yahoo_util.c
===================================================================
--- protocols/yahoo/yahoo_util.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ protocols/yahoo/yahoo_util.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,159 @@
+/*
+ * libyahoo2: yahoo_util.c
+ *
+ * Copyright (C) 2002-2004, Philip S Tellis <philip.tellis AT gmx.net>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#if HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#if STDC_HEADERS
+# include <string.h>
+#else
+# if !HAVE_STRCHR
+#  define strchr index
+#  define strrchr rindex
+# endif
+char *strchr (), *strrchr ();
+# if !HAVE_MEMCPY
+#  define memcpy(d, s, n) bcopy ((s), (d), (n))
+#  define memmove(d, s, n) bcopy ((s), (d), (n))
+# endif
+#endif
+
+#include "yahoo_util.h"
+
+char * y_string_append(char * string, char * append)
+{
+	int size = strlen(string) + strlen(append) + 1;
+	char * new_string = y_renew(char, string, size);
+
+	if(new_string == NULL) {
+		new_string = y_new(char, size);
+		strcpy(new_string, string);
+		FREE(string);
+	}
+
+	strcat(new_string, append);
+
+	return new_string;
+}
+
+char * y_str_to_utf8(const char *in)
+{
+	unsigned int n, i = 0;
+	char *result = NULL;
+
+	if(in == NULL || *in == '\0')
+		return "";
+	
+	result = y_new(char, strlen(in) * 2 + 1);
+
+	/* convert a string to UTF-8 Format */
+	for (n = 0; n < strlen(in); n++) {
+		unsigned char c = (unsigned char)in[n];
+
+		if (c < 128) {
+			result[i++] = (char) c;
+		} else {
+			result[i++] = (char) ((c >> 6) | 192);
+			result[i++] = (char) ((c & 63) | 128);
+		}
+	}
+	result[i] = '\0';
+	return result;
+}
+
+char * y_utf8_to_str(const char *in)
+{
+	int i = 0;
+	unsigned int n;
+	char *result = NULL;
+
+	if(in == NULL || *in == '\0')
+		return "";
+	
+	result = y_new(char, strlen(in) + 1);
+
+	/* convert a string from UTF-8 Format */
+	for (n = 0; n < strlen(in); n++) {
+		unsigned char c = in[n];
+
+		if (c < 128) {
+			result[i++] = (char) c;
+		} else {
+			result[i++] = (c << 6) | (in[++n] & 63);
+		}
+	}
+	result[i] = '\0';
+	return result;
+}
+
+#if !HAVE_GLIB
+
+void y_strfreev(char ** vector)
+{
+	char **v;
+	for(v = vector; *v; v++) {
+		FREE(*v);
+	}
+	FREE(vector);
+}
+
+char ** y_strsplit(char * str, char * sep, int nelem)
+{
+	char ** vector;
+	char *s, *p;
+	int i=0;
+	int l = strlen(sep);
+	if(nelem < 0) {
+		char * s;
+		nelem=0;
+		for(s=strstr(str, sep); s; s=strstr(s+l, sep),nelem++)
+			;
+		if(strcmp(str+strlen(str)-l, sep))
+			nelem++;
+	}
+
+	vector = y_new(char *, nelem + 1);
+
+	for(p=str, s=strstr(p,sep); i<nelem && s; p=s+l, s=strstr(p,sep), i++) {
+		int len = s-p;
+		vector[i] = y_new(char, len+1);
+		strncpy(vector[i], p, len);
+		vector[i][len] = '\0';
+	}
+
+	if(i<nelem) /* str didn't end with sep */
+		vector[i++] = strdup(p);
+			
+	vector[i] = NULL;
+
+	return vector;
+}
+
+void * y_memdup(const void * addr, int n)
+{
+	void * new_chunk = malloc(n);
+	if(new_chunk)
+		memcpy(new_chunk, addr, n);
+	return new_chunk;
+}
+
+#endif
Index: protocols/yahoo/yahoo_util.h
===================================================================
--- protocols/yahoo/yahoo_util.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
+++ protocols/yahoo/yahoo_util.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -0,0 +1,102 @@
+/*
+ * libyahoo2: yahoo_util.h
+ *
+ * Copyright (C) 2002-2004, Philip S Tellis <philip.tellis AT gmx.net>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#ifndef __YAHOO_UTIL_H__
+#define __YAHOO_UTIL_H__
+
+#if HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#if HAVE_GLIB
+# include <glib.h>
+
+# define FREE(x)	if(x) {g_free(x); x=NULL;}
+
+# define y_new		g_new
+# define y_new0		g_new0
+# define y_renew	g_renew
+
+# define y_memdup	g_memdup
+# define y_strsplit	g_strsplit
+# define y_strfreev	g_strfreev
+# ifndef strdup
+#  define strdup	g_strdup
+# endif
+# ifndef strncasecmp
+#  define strncasecmp	g_strncasecmp
+#  define strcasecmp	g_strcasecmp
+# endif
+
+# define snprintf	g_snprintf
+# define vsnprintf	g_vsnprintf
+
+#else
+
+# include <stdlib.h>
+# include <stdarg.h>
+
+# define FREE(x)		if(x) {free(x); x=NULL;}
+
+# define y_new(type, n)		(type *)malloc(sizeof(type) * (n))
+# define y_new0(type, n)	(type *)calloc((n), sizeof(type))
+# define y_renew(type, mem, n)	(type *)realloc(mem, n)
+
+void * y_memdup(const void * addr, int n);
+char ** y_strsplit(char * str, char * sep, int nelem);
+void y_strfreev(char ** vector);
+
+int strncasecmp(const char * s1, const char * s2, size_t n);
+int strcasecmp(const char * s1, const char * s2);
+
+char * strdup(const char *s);
+
+int snprintf(char *str, size_t size, const char *format, ...);
+int vsnprintf(char *str, size_t size, const char *format, va_list ap);
+
+#endif
+
+#ifndef TRUE
+#define TRUE 1
+#endif
+
+#ifndef FALSE
+#define FALSE 0
+#endif
+
+#ifndef MIN
+#define MIN(x,y) ((x)<(y)?(x):(y))
+#endif
+
+#ifndef MAX
+#define MAX(x,y) ((x)>(y)?(x):(y))
+#endif
+
+/* 
+ * The following three functions return newly allocated memory.
+ * You must free it yourself
+ */
+char * y_string_append(char * str, char * append);
+char * y_str_to_utf8(const char * in);
+char * y_utf8_to_str(const char * in);
+
+#endif
+
Index: query.c
===================================================================
--- query.c	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ query.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,3 +1,3 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -27,171 +27,142 @@
 #include "bitlbee.h"
 
-static void query_display(irc_t *irc, query_t *q);
-static query_t *query_default(irc_t *irc);
+static void query_display( irc_t *irc, query_t *q );
+static query_t *query_default( irc_t *irc );
 
-query_t *query_add(irc_t *irc, struct im_connection *ic, char *question,
-                   query_callback yes, query_callback no, query_callback free,
-                   void *data)
+query_t *query_add( irc_t *irc, struct gaim_connection *gc, char *question, void *yes, void *no, void *data )
 {
-	query_t *q = g_new0(query_t, 1);
-
-	q->ic = ic;
-	q->question = g_strdup(question);
+	query_t *q = g_new0( query_t, 1 );
+	
+	q->gc = gc;
+	q->question = g_strdup( question );
 	q->yes = yes;
 	q->no = no;
-	q->free = free;
 	q->data = data;
-
-	if (strchr(irc->umode, 'b') != NULL) {
-		char *s;
-
-		/* At least for the machine-parseable version, get rid of
-		   newlines to make "parsing" easier. */
-		for (s = q->question; *s; s++) {
-			if (*s == '\r' || *s == '\n') {
-				*s = ' ';
-			}
-		}
+	
+	if( irc->queries )
+	{
+		query_t *l = irc->queries;
+		
+		while( l->next ) l = l->next;
+		l->next = q;
 	}
-
-	if (irc->queries) {
-		query_t *l = irc->queries;
-
-		while (l->next) {
-			l = l->next;
-		}
-		l->next = q;
-	} else {
+	else
+	{
 		irc->queries = q;
 	}
-
-	if (g_strcasecmp(set_getstr(&irc->b->set, "query_order"), "lifo") == 0 || irc->queries == q) {
-		query_display(irc, q);
-	}
-
-	return(q);
+	
+	if( g_strcasecmp( set_getstr( irc, "query_order" ), "lifo" ) == 0 || irc->queries == q )
+		query_display( irc, q );
+	
+	return( q );
 }
 
-void query_del(irc_t *irc, query_t *q)
+void query_del( irc_t *irc, query_t *q )
 {
 	query_t *l;
-
-	if (irc->queries == q) {
+	
+	if( irc->queries == q )
+	{
 		irc->queries = q->next;
-	} else {
-		for (l = irc->queries; l; l = l->next) {
-			if (l->next == q) {
+	}
+	else
+	{
+		for( l = irc->queries; l; l = l->next )
+		{
+			if( l->next == q )
+			{
 				l->next = q->next;
 				break;
 			}
 		}
-
-		if (!l) {
+		
+		if( !l )
 			return; /* Hrmmm... */
-		}
 	}
-
-	g_free(q->question);
-	if (q->free && q->data) {
-		q->free(q->data);
-	}
-	g_free(q);
+	
+	g_free( q->question );
+	if( q->data ) g_free( q->data ); /* Memory leak... */
+	g_free( q );
 }
 
-void query_del_by_conn(irc_t *irc, struct im_connection *ic)
+void query_del_by_gc( irc_t *irc, struct gaim_connection *gc )
 {
 	query_t *q, *n, *def;
 	int count = 0;
-
-	if (!ic) {
-		return;
-	}
-
+	
 	q = irc->queries;
-	def = query_default(irc);
-
-	while (q) {
-		if (q->ic == ic) {
+	def = query_default( irc );
+	
+	while( q )
+	{
+		if( q->gc == gc )
+		{
 			n = q->next;
-			query_del(irc, q);
+			query_del( irc, q );
 			q = n;
-
-			count++;
-		} else {
+			
+			count ++;
+		}
+		else
+		{
 			q = q->next;
 		}
 	}
-
-	if (count > 0) {
-		imcb_log(ic, "Flushed %d unanswered question(s) for this connection.", count);
-	}
-
-	q = query_default(irc);
-	if (q && q != def) {
-		query_display(irc, q);
-	}
+	
+	if( count > 0 )
+		serv_got_crap( gc, "Flushed %d unanswered question(s) for this connection.", count );
+	
+	q = query_default( irc );
+	if( q && q != def )
+		query_display( irc, q );
 }
 
-void query_answer(irc_t *irc, query_t *q, int ans)
+void query_answer( irc_t *irc, query_t *q, int ans )
 {
 	int disp = 0;
-
-	if (!q) {
-		q = query_default(irc);
+	
+	if( !q )
+	{
+		q = query_default( irc );
 		disp = 1;
 	}
-	if (ans) {
-		if (q->ic) {
-			imcb_log(q->ic, "Accepted: %s", q->question);
-		} else {
-			irc_rootmsg(irc, "Accepted: %s", q->question);
-		}
-		if (q->yes) {
-			q->yes(q->data);
-		}
-	} else {
-		if (q->ic) {
-			imcb_log(q->ic, "Rejected: %s", q->question);
-		} else {
-			irc_rootmsg(irc, "Rejected: %s", q->question);
-		}
-		if (q->no) {
-			q->no(q->data);
-		}
+	
+	if( ans )
+	{
+		q->yes( NULL, q->data );
+		irc_usermsg( irc, "Accepted: %s", q->question );
+	}
+	else
+	{
+		q->no( NULL, q->data );
+		irc_usermsg( irc, "Rejected: %s", q->question );
 	}
 	q->data = NULL;
-
-	query_del(irc, q);
-
-	if (disp && (q = query_default(irc))) {
-		query_display(irc, q);
-	}
+	
+	query_del( irc, q );
+	
+	if( disp && ( q = query_default( irc ) ) )
+		query_display( irc, q );
 }
 
-static void query_display(irc_t *irc, query_t *q)
+static void query_display( irc_t *irc, query_t *q )
 {
-	if (q->ic) {
-		imcb_log(q->ic,
-		         "New request: %s\nYou can use the \2yes\2/\2no\2 commands to accept/reject this request.",
-		         q->question);
-	} else {
-		irc_rootmsg(irc,
-		            "New request: %s\nYou can use the \2yes\2/\2no\2 commands to accept/reject this request.",
-		            q->question);
-	}
+	if( q->gc )
+		irc_usermsg( irc, "Question on %s connection (handle %s):", proto_name[q->gc->protocol], q->gc->username );
+	else
+		irc_usermsg( irc, "Question:" );
+	
+	irc_usermsg( irc, "%s\nYou can use the yes/no commands to answer this question.", q->question );
 }
 
-static query_t *query_default(irc_t *irc)
+static query_t *query_default( irc_t *irc )
 {
 	query_t *q;
-
-	if (g_strcasecmp(set_getstr(&irc->b->set, "query_order"), "fifo") == 0) {
+	
+	if( g_strcasecmp( set_getstr( irc, "query_order" ), "fifo" ) == 0 )
 		q = irc->queries;
-	} else {
-		for (q = irc->queries; q && q->next; q = q->next) {
-			;
-		}
-	}
-
-	return(q);
+	else
+		for( q = irc->queries; q && q->next; q = q->next );
+	
+	return( q );
 }
Index: query.h
===================================================================
--- query.h	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ query.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,3 +1,3 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
@@ -20,6 +20,6 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
@@ -27,20 +27,18 @@
 #define _QUERY_H
 
-typedef void (*query_callback) (void *data);
-
-typedef struct query {
-	struct im_connection *ic;
+typedef struct query
+{
+	struct gaim_connection *gc;
 	char *question;
-	query_callback yes, no, free;
+	void (* yes) ( gpointer w, void *data );
+	void (* no) ( gpointer w, void *data );
 	void *data;
 	struct query *next;
 } query_t;
 
-query_t *query_add(irc_t *irc, struct im_connection *ic, char *question,
-                   query_callback yes, query_callback no, query_callback free,
-                   void *data);
-void query_del(irc_t *irc, query_t *q);
-void query_del_by_conn(irc_t *irc, struct im_connection *ic);
-void query_answer(irc_t *irc, query_t *q, int ans);
+query_t *query_add( irc_t *irc, struct gaim_connection *gc, char *question, void *yes, void *no, void *data );
+void query_del( irc_t *irc, query_t *q );
+void query_del_by_gc( irc_t *irc, struct gaim_connection *gc );
+void query_answer( irc_t *irc, query_t *q, int ans );
 
 #endif
Index: set.c
===================================================================
--- set.c	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ set.c	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,6 +1,6 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2013 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -20,267 +20,202 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
-
 #define BITLBEE_CORE
 #include "bitlbee.h"
 
-/* Used to use NULL for this, but NULL is actually a "valid" value. */
-char *SET_INVALID = "nee";
-
-set_t *set_add(set_t **head, const char *key, const char *def, set_eval eval, void *data)
-{
-	set_t *s = set_find(head, key);
-
-	/* Possibly the setting already exists. If it doesn't exist yet,
-	   we create it. If it does, we'll just change the default. */
-	if (!s) {
-		if ((s = *head)) {
-			/* Sorted insertion. Special-case insertion at the start. */
-			if (strcmp(key, s->key) < 0) {
-				s = g_new0(set_t, 1);
-				s->next = *head;
-				*head = s;
-			} else {
-				while (s->next && strcmp(key, s->next->key) > 0) {
-					s = s->next;
-				}
-				set_t *last_next = s->next;
-				s->next = g_new0(set_t, 1);
-				s = s->next;
-				s->next = last_next;
-			}
-		} else {
-			s = *head = g_new0(set_t, 1);
+set_t *set_add( irc_t *irc, char *key, char *def, void *eval )
+{
+	set_t *s = set_find( irc, key );
+	
+	if( !s )
+	{
+		if( ( s = irc->set ) )
+		{
+			while( s->next ) s = s->next;
+			s->next = g_new ( set_t, 1 );
+			s = s->next;
 		}
-		s->key = g_strdup(key);
-	}
-
-	if (s->def) {
-		g_free(s->def);
+		else
+		{
+			s = irc->set = g_new( set_t, 1 );
+		}
+		memset( s, 0, sizeof( set_t ) );
+		s->key = g_strdup( key );
+	}
+	
+	if( s->def )
+	{
+		g_free( s->def );
 		s->def = NULL;
 	}
-	if (def) {
-		s->def = g_strdup(def);
-	}
-
-	s->eval = eval;
-	s->data = data;
-
-	return s;
-}
-
-set_t *set_find(set_t **head, const char *key)
-{
-	set_t *s = *head;
-
-	while (s) {
-		if (g_strcasecmp(s->key, key) == 0 ||
-		    (s->old_key && g_strcasecmp(s->old_key, key) == 0)) {
+	if( def ) s->def = g_strdup( def );
+	
+	if( s->eval )
+	{
+		g_free( s->eval );
+		s->eval = NULL;
+	}
+	if( eval ) s->eval = eval;
+	
+	return( s );
+}
+
+set_t *set_find( irc_t *irc, char *key )
+{
+	set_t *s = irc->set;
+	
+	while( s )
+	{
+		if( g_strcasecmp( s->key, key ) == 0 )
 			break;
-		}
 		s = s->next;
 	}
-
-	return s;
-}
-
-char *set_getstr(set_t **head, const char *key)
-{
-	set_t *s = set_find(head, key);
-
-	if (!s || (!s->value && !s->def)) {
-		return NULL;
-	}
-
-	return set_value(s);
-}
-
-int set_getint(set_t **head, const char *key)
-{
-	char *s = set_getstr(head, key);
+	
+	return( s );
+}
+
+char *set_getstr( irc_t *irc, char *key )
+{
+	set_t *s = set_find( irc, key );
+	
+	if( !s || ( !s->value && !s->def ) )
+		return( NULL );
+	
+	return( s->value?s->value:s->def );
+}
+
+int set_getint( irc_t *irc, char *key )
+{
+	char *s = set_getstr( irc, key );
 	int i = 0;
-
-	if (!s) {
-		return 0;
-	}
-
-	if (sscanf(s, "%d", &i) != 1) {
-		return 0;
-	}
-
-	return i;
-}
-
-int set_getbool(set_t **head, const char *key)
-{
-	char *s = set_getstr(head, key);
-
-	if (!s) {
-		return 0;
-	}
-
-	return bool2int(s);
-}
-
-int set_isvisible(set_t *set)
-{
-	/* the default value is not stored in value, only in def */
-	return !((set->flags & SET_HIDDEN) ||
-	         ((set->flags & SET_HIDDEN_DEFAULT) &&
-	          (set->value == NULL)));
-}
-
-int set_setstr(set_t **head, const char *key, char *value)
-{
-	set_t *s = set_find(head, key);
+	
+	if( !s )
+		return( 0 );
+	
+	if( ( g_strcasecmp( s, "true" ) == 0 ) || ( g_strcasecmp( s, "yes" ) == 0 ) || ( g_strcasecmp( s, "on" ) == 0 ) )
+		return( 1 );
+	
+	if( sscanf( s, "%d", &i ) != 1 )
+		return( 0 );
+	
+	return( i );
+}
+
+int set_setstr( irc_t *irc, char *key, char *value )
+{
+	set_t *s = set_find( irc, key );
 	char *nv = value;
-
-	if (!s) {
-		/*
-		Used to do this, but it never really made sense.
-		s = set_add( head, key, NULL, NULL, NULL );
-		*/
-		return 0;
-	}
-
-	if (value == NULL && (s->flags & SET_NULL_OK) == 0) {
-		return 0;
-	}
-
-	/* Call the evaluator. For invalid values, evaluators should now
-	   return SET_INVALID, but previously this was NULL. Try to handle
-	   that too if NULL is not an allowed value for this setting. */
-	if (s->eval && ((nv = s->eval(s, value)) == SET_INVALID ||
-	                ((s->flags & SET_NULL_OK) == 0 && nv == NULL))) {
-		return 0;
-	}
-
-	if (s->value) {
-		g_free(s->value);
+	
+	if( !s )
+		s = set_add( irc, key, NULL, NULL );
+	
+	if( s->eval && !( nv = s->eval( irc, s, value ) ) )
+		return( 0 );
+	
+	if( s->value )
+	{
+		g_free( s->value );
 		s->value = NULL;
 	}
-
-	/* If there's a default setting and it's equal to what we're trying to
-	   set, stick with s->value = NULL. Otherwise, remember the setting. */
-	if (!s->def || (g_strcmp0(nv, s->def) != 0)) {
-		s->value = g_strdup(nv);
-	}
-
-	if (nv != value) {
-		g_free(nv);
-	}
-
-	return 1;
-}
-
-int set_setint(set_t **head, const char *key, int value)
-{
-	char *s = g_strdup_printf("%d", value);
-	int retval = set_setstr(head, key, s);
-
-	g_free(s);
-	return retval;
-}
-
-void set_del(set_t **head, const char *key)
-{
-	set_t *s = *head, *t = NULL;
-
-	while (s) {
-		if (g_strcasecmp(s->key, key) == 0) {
+	
+	if( !s->def || ( strcmp( nv, s->def ) != 0 ) )
+		s->value = g_strdup( nv );
+	
+	if( nv != value )
+		g_free( nv );
+	
+	return( 1 );
+}
+
+int set_setint( irc_t *irc, char *key, int value )
+{
+	char s[24];	/* Not quite 128-bit clean eh? ;-) */
+	
+	sprintf( s, "%d", value );
+	return( set_setstr( irc, key, s ) );
+}
+
+void set_del( irc_t *irc, char *key )
+{
+	set_t *s = irc->set, *t = NULL;
+	
+	while( s )
+	{
+		if( g_strcasecmp( s->key, key ) == 0 )
 			break;
-		}
-		s = (t = s)->next;
-	}
-	if (s) {
-		if (t) {
-			t->next = s->next;
-		} else {
-			*head = s->next;
-		}
-
-		g_free(s->key);
-		g_free(s->old_key);
-		g_free(s->value);
-		g_free(s->def);
-		g_free(s);
-	}
-}
-
-int set_reset(set_t **head, const char *key)
-{
-	set_t *s;
-
-	s = set_find(head, key);
-	if (s) {
-		return set_setstr(head, key, s->def);
-	}
-
-	return 0;
-}
-
-char *set_eval_int(set_t *set, char *value)
+		s = (t=s)->next;
+	}
+	if( s )
+	{
+		t->next = s->next;
+		g_free( s->key );
+		if( s->value ) g_free( s->value );
+		if( s->def ) g_free( s->def );
+		g_free( s );
+	}
+}
+
+char *set_eval_int( irc_t *irc, set_t *set, char *value )
 {
 	char *s = value;
-
-	/* Allow a minus at the first position. */
-	if (*s == '-') {
-		s++;
-	}
-
-	for (; *s; s++) {
-		if (!g_ascii_isdigit(*s)) {
-			return SET_INVALID;
-		}
-	}
-
-	return value;
-}
-
-char *set_eval_bool(set_t *set, char *value)
-{
-	return is_bool(value) ? value : SET_INVALID;
-}
-
-char *set_eval_list(set_t *set, char *value)
-{
-	GSList *options = set->eval_data, *opt;
-
-	for (opt = options; opt; opt = opt->next) {
-		if (strcmp(value, opt->data) == 0) {
-			return value;
-		}
-	}
-
-	/* TODO: It'd be nice to show the user a list of allowed values,
-	         but we don't have enough context here to do that. May
-	         want to fix that. */
-
-	return NULL;
-}
-
-char *set_eval_to_char(set_t *set, char *value)
-{
-	char *s = g_new(char, 3);
-
-	if (*value == ' ') {
-		strcpy(s, " ");
-	} else {
-		sprintf(s, "%c ", *value);
-	}
-
-	return s;
-}
-
-char *set_eval_oauth(set_t *set, char *value)
-{
-	account_t *acc = set->data;
-
-	if (bool2int(value) && strcmp(acc->pass, PASSWORD_PENDING) == 0) {
-		*acc->pass = '\0';
-	}
-
-	return set_eval_bool(set, value);
-}
+	
+	for( ; *s; s ++ )
+		if( *s < '0' || *s > '9' )
+			return( NULL );
+	
+	return( value );
+}
+
+char *set_eval_bool( irc_t *irc, set_t *set, char *value )
+{
+	if( ( g_strcasecmp( value, "true" ) == 0 ) || ( g_strcasecmp( value, "yes" ) == 0 ) || ( g_strcasecmp( value, "on" ) == 0 ) )
+		return( value );
+	if( ( g_strcasecmp( value, "false" ) == 0 ) || ( g_strcasecmp( value, "no" ) == 0 ) || ( g_strcasecmp( value, "off" ) == 0 ) )
+		return( value );
+	return( set_eval_int( irc, set, value ) );
+}
+
+char *set_eval_to_char( irc_t *irc, set_t *set, char *value )
+{
+	char *s = g_new( char, 3 );
+	
+	if( *value == ' ' )
+		strcpy( s, " " );
+	else
+		sprintf( s, "%c ", *value );
+	
+	return( s );
+}
+
+char *set_eval_ops( irc_t *irc, set_t *set, char *value )
+{
+	if( g_strcasecmp( value, "user" ) == 0 )
+	{
+		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
+		                                              irc->channel, "+o-o", irc->nick, irc->mynick );
+		return( value );
+	}
+	else if( g_strcasecmp( value, "root" ) == 0 )
+	{
+		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
+		                                              irc->channel, "-o+o", irc->nick, irc->mynick );
+		return( value );
+	}
+	else if( g_strcasecmp( value, "both" ) == 0 )
+	{
+		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
+		                                              irc->channel, "+oo", irc->nick, irc->mynick );
+		return( value );
+	}
+	else if( g_strcasecmp( value, "none" ) == 0 )
+	{
+		irc_write( irc, ":%s!%s@%s MODE %s %s %s %s", irc->mynick, irc->mynick, irc->myhost,
+		                                              irc->channel, "-oo", irc->nick, irc->mynick );
+		return( value );
+	}
+	
+	return( NULL );
+}
+
Index: set.h
===================================================================
--- set.h	(revision 210d1d9cf4366d9933c02383300175e4b573be61)
+++ set.h	(revision b7d3cc34f68dab7b8f7d0777711317b334fc2219)
@@ -1,6 +1,6 @@
-/********************************************************************\
+  /********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
-  * Copyright 2002-2006 Wilmer van der Gaast and others                *
+  * Copyright 2002-2004 Wilmer van der Gaast and others                *
   \********************************************************************/
 
@@ -20,97 +20,33 @@
   You should have received a copy of the GNU General Public License with
   the Debian GNU/Linux distribution in /usr/share/common-licenses/GPL;
-  if not, write to the Free Software Foundation, Inc., 51 Franklin St.,
-  Fifth Floor, Boston, MA  02110-1301  USA
+  if not, write to the Free Software Foundation, Inc., 59 Temple Place,
+  Suite 330, Boston, MA  02111-1307  USA
 */
 
-#ifndef __SET_H__
-#define __SET_H__
-
-struct set;
-
-/* This used to be specific to irc_t structures, but it's more generic now
-   (so it can also be used for account_t structs). It's pretty simple, but
-   so far pretty useful.
-
-   In short, it just keeps a linked list of settings/variables and it also
-   remembers a default value for every setting. And to prevent the user
-   from setting invalid values, you can write an evaluator function for
-   every setting, which can check a new value and block it by returning
-   NULL, or replace it by returning a new value. See struct set.eval. */
-
-typedef char *(*set_eval) (struct set *set, char *value);
-
-extern char *SET_INVALID;
-
-typedef enum {
-	SET_NOSAVE = 0x0001,   /* Don't save this setting (i.e. stored elsewhere). */
-	SET_NULL_OK = 0x0100,  /* set->value == NULL is allowed. */
-	SET_HIDDEN = 0x0200,   /* Don't show up in setting lists. Mostly for internal storage. */
-	SET_PASSWORD = 0x0400, /* Value shows up in settings list as "********". */
-	SET_HIDDEN_DEFAULT = 0x0800, /* Hide unless changed from default. */
-	SET_LOCKED = 0x1000    /* Setting is locked, don't allow changing it */
-} set_flags_t;
-
-typedef struct set {
-	void *data;     /* Here you can save a pointer to the
-	                   object this settings belongs to. */
-
+typedef struct set
+{
 	char *key;
-	char *old_key;  /* Previously known as; for smooth upgrades. */
 	char *value;
-	char *def;      /* Default value. If the set_setstr() function
-	                   notices a new value is exactly the same as
-	                   the default, value gets set to NULL. So when
-	                   you read a setting, don't forget about this!
-	                   In fact, you should only read values using
-	                   set_getstr/int(). */
-
-	set_flags_t flags; /* Mostly defined per user. */
-
-	/* Eval: Returns SET_INVALID if the value is incorrect, exactly
-	   the passed value variable, or a corrected value. In case of
-	   the latter, set_setstr() will free() the returned string! */
-	set_eval eval;
-	void *eval_data;
+	char *def;	/* Default */
+	
+	/* Eval: Returns NULL if the value is incorrect. Can return a
+	   corrected value. set_setstr() should be able to free() the
+	   returned string! */
+	char *(*eval) ( irc_t *irc, struct set *set, char *value );
 	struct set *next;
 } set_t;
 
-#define set_value(set) ((set)->value) ? ((set)->value) : ((set)->def)
+set_t *set_add( irc_t *irc, char *key, char *def, void *eval );
+G_MODULE_EXPORT set_t *set_find( irc_t *irc, char *key );
+G_MODULE_EXPORT char *set_getstr( irc_t *irc, char *key );
+G_MODULE_EXPORT int set_getint( irc_t *irc, char *key );
+int set_setstr( irc_t *irc, char *key, char *value );
+int set_setint( irc_t *irc, char *key, int value );
+void set_del( irc_t *irc, char *key );
 
-/* Should be pretty clear. */
-set_t *set_add(set_t **head, const char *key, const char *def, set_eval eval, void *data);
+char *set_eval_int( irc_t *irc, set_t *set, char *value );
+char *set_eval_bool( irc_t *irc, set_t *set, char *value );
+char *set_eval_to_char( irc_t *irc, set_t *set, char *value );
+char *set_eval_ops( irc_t *irc, set_t *set, char *value );
 
-/* Returns the raw set_t. Might be useful sometimes. */
-set_t *set_find(set_t **head, const char *key);
 
-/* Returns a pointer to the string value of this setting. Don't modify the
-   returned string, and don't free() it! */
-G_MODULE_EXPORT char *set_getstr(set_t **head, const char *key);
-
-/* Get an integer. In previous versions set_getint() was also used to read
-   boolean values, but this SHOULD be done with set_getbool() now! */
-G_MODULE_EXPORT int set_getint(set_t **head, const char *key);
-G_MODULE_EXPORT int set_getbool(set_t **head, const char *key);
-
-/* set_setstr() strdup()s the given value, so after using this function
-   you can free() it, if you want. */
-int set_setstr(set_t **head, const char *key, char *value);
-int set_setint(set_t **head, const char *key, int value);
-void set_del(set_t **head, const char *key);
-int set_reset(set_t **head, const char *key);
-
-/* returns true if a setting shall be shown to the user */
-int set_isvisible(set_t *set);
-
-/* Two very useful generic evaluators. */
-char *set_eval_int(set_t *set, char *value);
-char *set_eval_bool(set_t *set, char *value);
-
-/* Another more complicated one. */
-char *set_eval_list(set_t *set, char *value);
-
-/* Some not very generic evaluators that really shouldn't be here... */
-char *set_eval_to_char(set_t *set, char *value);
-char *set_eval_oauth(set_t *set, char *value);
-
-#endif /* __SET_H__ */
